# Features

## Grundfunktionen in der Übersicht

- Merkmale entfernen oder sortieren in bestimmten Kategorien, Herstellern, Spezialseiten (Bestseller, Sonderangebote, ...), Merkmalwertseiten und der Suche
- Umsortieren von Merkmalen auf bestimmten Artikeldetailseiten (Artikel einer bestimmten Kategorie)
- Sortieren von Merkmalwerten (natürlich, numerisch, alphabetisch, nach Anzahl der Ergebnisse) **unabhängig** von der Sortierung in JTL-WaWi

# Dokumentation

Diese Dokumentation bezieht sich auf Version 2 des Plugins, welche für JTL-Shop 5 erschienen ist.

Wir bieten Feature Sorter ebenfalls für JTL-Shop 4 an. Das Plugin hat in dieser Shopversionen allerdings teils andere Reiter und Einstellungen. Bitte beachte hierzu den Abschnitt **Besonderheiten in JTL-Shop 4** weiter unten!

## Installation

Unser Feature Sorter Plugin ist wie jedes unserer Plugins für den JTL Shop schnell und einfach zu installieren, lies hierzu bitte die Infos [in unserem WiKi](https://kreativkonzentrat.de/wiki/plugins/install) oder [im JTL Guide](https://guide.jtl-software.de/jtl-shop-4/shop-erweitern/plugins-fuer-jtl-shop-verwalten).

Ein **Update von Version 1.09 auf Version 2.0.0** ist leider nicht möglich. Da sich auch Datenbankstruktur geändert hat, müssen wir dich bitten, deine Sortierungen aus JTL-Shop 4 ggf. neu einzugeben.

## Der Reiter Merkmale sortieren

Hier kannst du die Auswahl der Merkmale und ihre Reihenfolge festlegen. Dies ist jeweils für Artikellisten des **Typs** Kategorie, Hersteller, Merkmalwert, Spezialseiten, Suche und auch für Artikeldetailseiten möglich.

### Spezielle Sortierungen

Wenn du die Sortierung bspw. nicht auf eine spezielle Kategorie oder einen speziellen Hersteller beschränken möchtest, verwende bei der Auswahl einer Sortierung "Alle Kategorien" oder "Alle Hersteller". Die Sortierung wird dann für alle Kategorie- und Herstellerseiten verwendet, für die es keine speziellen Regeln gibt. 

Auch ist die Anlage von Sortierungen für Artikeldetailseiten bestimmter Kategorien möglich. Wähle hierzu den Typ "Produkte der Kategorie". 
Bitte beachte, dass Merkmale auch für **alle Seiten** entfernt oder als Standard gesetzt werden können, mehr dazu unter "Fixe Merkmale und globales Entfernen".  

### Sortierungen vererben & unsortierte Merkmale anhängen

Bei Sortierungen für Kategorieseiten ist es möglich, diese auf Unterkategorien zu **vererben**. Diese Vererbung greift solange, bis eine speziellere Sortierregel für die Kategorie gefunden wird. 

Merkmale, die nicht in einer Sortierregel vorkommen, können wahlweise angehangen oder entfernt werden. Neben der globalen Einstellung (siehe "Einstellungen") kann diese Option für jede Regel einzeln gesetzt werden.  

**Tipp:** wenn du Merkmalfilter auf einer Seite komplett entfernen möchtest, lasse Merkmalauswahl leer und deaktiviere die Option zum Anhängen der Merkmale. 

### Sortierungen editieren und löschen

Eine Tabelle zeigt dir eine Übersicht deiner bisherigen Sortieregeln. Editiere oder lösche den jeweiligen Eintrag über die Action-Buttons in der rechten Spalte.   

### Sortierungen aufräumen

Mit einem Klick auf den Button "Sortierungen aufräumen" werden alle Sortierungen gelöscht, für die keine valide Shopseite gefunden werden konnte. 
Das ist z.B. dann der Fall, wenn eine Kategorie dauerhaft gelöscht wurde. Eine vormals angelegte Sortierung für diese Kategorie würde daher gelöscht werden.   

### Fixe Merkmale und globales Entfernen

Es ist möglich, Merkmale **global zu entfernen** oder zu **fixieren**, d.h. nach vorn zu sortieren. Du findest die Auswahl dieser Merkmale unter der Tabelle deiner bisherigen Sortierungen.

**Bitte beachte**, dass diese globalen Regeln wirklich immer gelten, d.h. auf jeder Seite Anwendung finden, wo Sortierungen angelegt werden könnten.

## Der Reiter Merkmalwerte sortieren

Hier kannst du die Sortierung der Merkmalwerte bestimmen. Diese gilt für alle Werte des Merkmals und überschreibt ggf. Sortierungsangaben in der JTL WaWi. 

Hierdurch ist es bspw. möglich, Werte eines Merkmals **"geeignet ab"** wie `ab 12 Jahren`, `ab 6 Jahren`, `ab 18 Jahren` ohne Eingriff in die WaWi zu sortieren. Die Typangabe `Zahl` würde die Werte wie folgt sortieren: `ab 6 Jahren`, `ab 12 Jahren`, `ab 18 Jahren`. Beachte hierzu auch die Stopwörter im Reiter Einstellungen!

Merkmalwerte können auch nach der **Anzahl der Ergebnisse** sortiert werden. Merkmalwerte, die die meisten Produktergebnisse für die aktuelle Listenansicht liefern, werden mit dieser Methode nach oben sortiert.  

In den meisten Fällen wird die **natürliche Sortierung** die besten Wahl sein. Hierbei versucht das Plugin, Merkmalwerte "menschlich" zu sortieren, was bei der Kombination von Zahlen und Einheiten meist zu sehr guten Ergebnissen führt, auch ohne die Verwendung von Stopwörtern. 

## Der Reiter Einstellungen

In den Einstellungen kann festgelegt werden, was mit Merkmalen passiert, die bei der Merkmalsortierung nicht angegeben wurden (Einstellung **Unsortierte Merkmale anhängen?**) 
Sie können entweder unsortiert angehängt oder ausgeblendet werden.

Wähle bei der Einstellung **"Standard Merkmalwertsortierung alphabetisch?"** den Wert `Ja`, wenn du die Sortierungsangaben der Merkmalwerte in der JTL WaWi ignorieren und standardmäßig eine alphabetische Sortierung deiner Merkmalwerte möchtest.

Im Feld **Stopwörter Merkmalwertsortierung** kannst du Zeichenketten festlegen, die vor einer Interpretation des Merkmalwertes bei der Merkmalwertsortierung entfernt werden sollen. So kannst du die Erkennung von Zahlen in Merkmalwerten wie "ab 18 Jahren" oder "ca. 23,3 cm" verbessern (passende Stopwörter hier: `ab, Jahren, ca., cm`). Trenne mehrere Stopwörter mit einem Komma. 

Ab Version 2.x kannst du festlegen, ob deine **Kategorieregeln auch auf Artikelseiten** angewendet werden sollen. Dies ersetzt den Sortierungstyp "Produkte der Kategorie" aus älteren Versionen des Plugins. Legst du bspw. eine Sortierregel für die Kategorie "Blumenwiesen" an und aktivierst diese Option, werden Merkmale auch auf Produktseiten der Kategorie "Blumenwiesen" gemäß der Regel sortiert.

# Besonderheiten in JTL-Shop 4

## Merkmale via Namen sortieren

In Version 1.x werden Merkmale noch anhand ihrer Namen (oder später auch IDs) sortiert. Im Feld **Sortierung** gibst du eine Liste von Namen und IDs (umschlossen von "[[" und "]]") der Merkmale ein und trennst die einzelnen Werte mit einem Trennzeichen (Standard ","). 

Beispiel: `Größe, Art und Weise, Farbe, [[13]]`.

## Einstellung zum Trennzeichen

Ab Version 1.08 kannst du auch das **Trennzeichen für die Merkmalsortierung** definieren. Im Standard wird hier das Komma `,` gesetzt. Sollten deinen Merkmalnamen selbst Kommata enthalten, kann dir diese Option also helfen.

## Merkmale via IDs sortieren

Nutzt du in Version 1.09 gleiche Namen für Merkmale oder hast einen mehrsprachigen Shop? Dann kann es sinnvoll ein, Merkmale nicht über deren Namen, sondern über ihre internen, einzigartigen IDs zu spezifizieren.

Umschließe den internen Schlüssel eins Merkmals mit `[[` und `]]` und trage diese in etwas so in die Sortierung ein: `Material, [[12]], [[41]], Farbe`.

Den internen Schlüssel deines Merkmals erfährst du bspw. mit dem Plugin [JTL Debug](https://jtl-devguide.readthedocs.io/projects/jtl-shop/de/latest/shop_programming_tips/debug.html). Suche in deinen Artikellisten mit aktivierten JTL Debug Overlay nach dem Merkmalnamen und prüfe `$Suchergebnisse->MerkmalFilter[INDEX]->kMerkmal`.

Auch die Liste der globalen Ausschlüsse und der fixierten Merkmale legst du in der Version für JTL-Shop 4 so an (Reiter "Einstellungen").

## Merkmale komplett entfernen

Wenn du Merkmalfilter auf einer Seite komplett entfernen möchtest, setze im Feld "Sortierung" den Wert `NONE` und deaktiviere die Option zum Anhängen der Merkmale. 


# Changelog

**2.0.1 - 13.12.2022**

- Bugfix: SQL Tabellen wurden teilweise durch ungünstig gewählte Datentyp-Größen nicht angelegt
- Debug Logging der Installations-Routinen

**2.0.0 - 09.11.2021**

- Version für JTL-Shop 5
- Auswahl und Sortierung der Merkmale mit benutzerfreundlichem Control
- globale Defaults und Ausschlüsse von Merkmalen ebenfalls via Control
- Nicht mehr benötigte Einstellungen entfernt

**1.09 - 03.12.2020**

- Feature: Sortierungen auch auf Artikeldetailseiten möglich
- Feature: Sortierungen in Kategorien auf Unterkategorien vererben
- Feature: Merkmale können auch via interne ID sortiert werden (bei gleichnamigen Merkmalen hilfreich)
- Feature: globale Defaults und Ausschlüsse von Merkmalen
- Feature: Sortierungen aufräumen (Sortierungen für nicht mehr vorhandene Kategorien etc. löschen)
- Feature: Natürlich Sortierung, sortiert Merkmalwerte "menschlich"
- Feature: einige Verbesserungen im Backend & Code Cleanup
- Bugfix: einige Merkmaltypen (z.B.: Selectbox) wurden nicht sortiert 

**1.08 - 08.09.2018**

- Feature: neue Sortiermöglichkeiten für Merkmalwerte (nach Anzahl der Ergebnisse; Zahl & Zeichenkette auch absteigend)
- Feature: Sortierung nach Suchbegriff (vorher nur für alle Suchen möglich)
- Feature: "Unsortierte Merkmale anhängen" für jede Sortierung individuell möglich
- Feature: eigene Trennzeichen zwischen Merkmalnamen in der Sortierung sind definierbar

**1.07 - 21.04.2017**

- Bugfix: entfernen aller Merkmale funktioniert wieder (Feld "Sortierung" leer lassen) 

**1.06 - 15.02.2017**

- Sortierung von Merkmalen auf Merkmalwertseiten möglich
- Stopwörter zur besseren Interpretation von Merkmalwerten, hilfreich bei der automatischen Merkmalwertsortierung
- besseres Select Control (inkl. Suche) beim Anlegen von Sortierungen
- kleinere Bugfixes und Code-Refactoring

**1.05 - 10.03.2016**

- Sortierung von Merkmalen auf Spezialseiten wie Sonderangebote, Bestseller etc. ist jetzt möglich 

**1.04 - 02.11.2015**

- Plugin ist kompatibel mit JTL Shop4 (vorwiegend optische Anpassungen im Backend)

**1.03 - 27.04.2015**

- Bugfix: alphabetische Sortierung der Merkmalwerte funktioniert nun korrekt
- Bugifx: Pluginvalidierung funktioniert nun auch bei Shops, die nur per "https" erreichbar sind

**1.02 - 09.02.2015**

- Optionen für "Alle Kategorien" und "Alle Hersteller" hinzugefügt

**1.01 - 06.08.2013**

- Problem beim Speichern von Sortierungen für die Suche behoben

**1.00 - 25.03.2013**

- erstes Release